// *********************(c)*2004*********************>
// -holzilib--holzilib--holzilib--holzilib--holzilib->
// ++++PD-External++by+Georg+Holzmann++grh@gmx.at++++>
//
// PDContainer: 
// this is a port of the containers from the C++ STL
// (Standard Template Library)
// for usage see the documentation and PD help files
// for license see readme.txt
//
// GlobalStuff.h 


#ifndef _global_stuff_h___
#define _global_stuff_h___


#include "m_pd.h"
#include <string>
#include <sstream>
#include <fstream>
#include <iterator>
#include <list>
//#include <iostream> //DEBUG

using std::string;
using std::ostringstream;
using std::istringstream;
using std::ofstream;
using std::ifstream;
using std::endl;

// current version
#define PDC_VERSION   "0.0.1pre"


//---------------------------------------------------
/* This function compares two pd t_atoms
 */
static bool compareAtoms(t_atom &atom1, t_atom &atom2)
{
  if(atom1.a_type == A_FLOAT && atom2.a_type == A_FLOAT)
    return (atom1.a_w.w_float == atom2.a_w.w_float);

  if(atom1.a_type == A_SYMBOL && atom2.a_type == A_SYMBOL)
    return (strcmp(atom1.a_w.w_symbol->s_name,
		   atom2.a_w.w_symbol->s_name) == 0);

  return false;
}


//---------------------------------------------------
/* one Element holds one data element, which can be 
 * a list, a float or a symbol
 */ 
class Element
{
 public:
  t_atom *atom;
  int length;

  Element() : atom(0), length(0) 
    { }

  // Copy Constr.    
  Element(const Element &src)
  {
    length = src.length;
    atom = (t_atom*)copybytes(src.atom, length * sizeof(t_atom));
  }

  //Assignement Operator
  const Element& operator = (const Element &src)
    {
      length = src.length;
      atom = (t_atom*)copybytes(src.atom, length * sizeof(t_atom));
      return (*this);
    }

  // operator== to compare the objects
  bool operator== (const Element &key) const
    {
      if (length != key.length)
	return false;

      for (int i=0; i < length; i++)
	{
	  if(!compareAtoms(atom[i],key.atom[i]))
	    return false;
	}

      return true;
    }

  // operator< to compare the objects
  // (needed by map, set, ...)
  bool operator< (const Element &key) const
    {
      if (length == key.length)
	{
	  bool difference = false;
	  int index;

	  for (index = 0; index<length; index++)
	    {
	      if(!compareAtoms(atom[index],key.atom[index]))
		{
		  difference = true;
		  break;
		}
	    }

	  if( atom[index].a_type == A_FLOAT 
	      && key.atom[index].a_type == A_SYMBOL )
	    return true;

	  if( atom[index].a_type == A_SYMBOL 
	      && key.atom[index].a_type == A_FLOAT )
	    return false;

	  if( atom[index].a_type == A_FLOAT 
	      && key.atom[index].a_type == A_FLOAT )
	    return (atom[index].a_w.w_float < key.atom[index].a_w.w_float);

	  if( atom[index].a_type == A_SYMBOL 
	      && key.atom[index].a_type == A_SYMBOL )
	    return (strcmp(atom[index].a_w.w_symbol->s_name,
			   key.atom[index].a_w.w_symbol->s_name) < 0); 
	
	  return false;  
	} // different length
      else
	return (length < key.length);

    }
};


#endif  //_global_stuff_h___
